/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	Offline教材 オフラインログのbkタグデータ保持クラス
//			変更履歴
//				2004.01.08	新規作成	二條　智文
//
package jp.co.ntt.lms.lo.Offline.OfflineLog;

import org.w3c.dom.*;
import java.util.*;

/**
 * Offline教材 オフラインログのbkタグデータ保持クラス<BR>
 * オフラインログの<lom>ノードを受け取り、自身の内部変数にデータを
 * 格納します。
 */
public class OfflineBk implements OfflineLogConst {

	// 自身のノードオブジェクトを保持します。
	private Element mobjBkElm = null;

	// エラーメッセージ
	private static final String ERR_PRE = "<loms>-<lom>-<bk>:";
	private static final String ERR_NOT_BK = ERR_PRE + "bkタグではありません。";
	private static final String ERR_NOEXIST_INUMBER = ERR_PRE + "i数字 タグが存在しません。";
	private static final String ERR_INVALID_MCNT = ERR_PRE + "mcnt属性が不正です。";
	private static final String ERR_INVALID_NCNT = ERR_PRE + "ncnt属性が不正です。";

	// <lom>-<bk>-[mcnt]属性値を保持します。
	private int mintMCNT;
	// <lom>-<bk>-[ncnt]属性値を保持します。
	private int mintNCNT;

	// <lom>-<bk>-<i数字>エレメントデータを保持します。
	private Vector mvecBkLog = new Vector();

	/**
	 * コンストラクタです。
	 * @param objNode bkエレメントオブジェクト
	 * @exception OfflineLogParseException パースエラー
	 */
	OfflineBk( Element objElement )
		throws OfflineLogParseException
	{
		// タグ名のチェック
		String strTagName = objElement.getTagName();
		if( strTagName == null || !strTagName.equals( LOM_BK_ELM ) ) {
			throw new OfflineLogParseException( ERR_NOT_BK );
		}

		mobjBkElm = objElement;

		parse();

	}

	/**
	 * <lom>-<bk>-[mcnt] 属性値を取得します。
	 * @return int <lom>-<bk>-[mcnt] 属性値
	 */
	public int getMCNT() {
		return mintMCNT;
	}

	/**
	 * <lom>-<bk>-[ncnt] 属性値を取得します。
	 * @return int <lom>-<bk>-[ncnt] 属性値
	 */
	public int getNCNT() {
		return mintNCNT;
	}

	/**
	 * <lom>-<bk>-<i数字>エレメントデータの長さを取得します。
	 * @return int 長さ
	 */
	public int getBkLogLength() {
		return mvecBkLog.size();
	}

	/**
	 * 指定されたインデックスの<lom>-<bk>-<i数字>エレメントデータを取得します。
	 * @return OfflineBkLog
	 */
	public OfflineBkLog getBkLog( int index ) {
		return (OfflineBkLog)mvecBkLog.get(index);
	}


//------------------------------------ 内部関数 --------------------------------
	/**
	 * コンストラクタで受け取ったエレメントないのデータを
	 * 取得して、自身の変数に格納します。
	 */
	private void parse()
		throws OfflineLogParseException
	{

		// 属性値の設定
		String strTemp = null;

		// <lom>-<bk>-[mcnt]属性を取得する
		strTemp = mobjBkElm.getAttribute( BK_MCNT_ATTR );
		try {
			mintMCNT = Integer.parseInt( strTemp );
		}
		catch( NumberFormatException ne ) {
			// 属性値が不正の場合は-1を格納する
			mintMCNT = -1;
		}

		// <lom>-<bk>-[ncnt]属性を取得する
		strTemp = mobjBkElm.getAttribute( BK_NCNT_ATTR );
		try {
			mintNCNT = Integer.parseInt( strTemp );
		}
		catch( NumberFormatException ne ) {
			// 属性値が不正の場合は -1 を格納する
			mintNCNT = -1;
		}


		// <lom>-<bk>-<i数字>エレメントデータの設定
		NodeList objLogList = mobjBkElm.getChildNodes();

		for( int i = 0; i < objLogList.getLength(); i++ ) {

			Node objNodeTemp = objLogList.item( i );

			String strNodeTitle = objNodeTemp.getNodeName();

			// ノード名が'i'で始まるノードを探す
			if( strNodeTitle.charAt(0) == LOM_BK_PRE ) {

				// 'i' の次の文字が数字のものを探す
				try {
					String strNum = strNodeTitle.substring( 1, strNodeTitle.length() );

					// 数値に変換する。
					int intNum = Integer.parseInt( strNum );

					mvecBkLog.add( new OfflineBkLog( (Element)objNodeTemp ) );
				}
				catch( NumberFormatException ne ) {}
				catch( IndexOutOfBoundsException  ie ) {}
			}
		}

		// 1件も存在しなかったらエラーとする
		if( mvecBkLog.size() == 0 ) {
			throw new OfflineLogParseException( ERR_NOEXIST_INUMBER );
		}

	}
//------------------------------------ 内部関数 --------------------------------
}

